<CsoundSynthesizer>
; coded by Oeyvind Brandtsegg 2002

; You need some specific soundfiles to run this orchestra,
; they should be distributed together with the csd file.
; Edit the lines of text following after the <CsScore> tag to 
; reflect the path where you have put these files.
; example:
; f1  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs1.wav"  0  0  0
; edit the text between the quote marks (")

; pardon for the very messy Csound code.
; This is a Csound setup for one song with the band Kroyt.
; It needs midi in and out, and audio out
; The midi out part could have been deleted when distributing this file,
; because it only relates to program change setup of the effects unit I use on my Vibraphone.
; But I've included it, just to let you see how this is done.

; The instrument is made up of a Bass synth, with percussion riffs being assigned to 
; different midi notes. Some notes has a "hardwired" midi split and thus play the same riff 
; each time the note is played on my midi Vibraphone. 
; (You can of course use a standard midi keyboard for testing)
; Other notes has a random selector for percussion riffs, choosing among a few similar riffs.
; Some notes has a fairly big Crash Cymbal sample assigned, and one note has a Boomy reverb Bass Drum.
;
; In addition, there's a drumloop sample that can be trigged by note number 53 (Low F on the Vibe),
; and the drumloop can be stopped by hitting note number 77 (two octaves up from the low F)
; The drumloop trigging mechanism is bypassed at the start of this orchestra,
; it can be enabled by sending midi controller number 3 with a value > 20
; This works as a on/off toggle switch, so the next time you go above value 20 on midi controller 2,
; the drumloop trigging is disabled.
; The reason for this setup is that I wanted to bew able to play those midi notes 
; without trigging a drumloop sometimes. 
; Midi controller 3 corresponds to one of my DimesionBeam midi IR controllers,
; so on stage, I just wave my hand at the DimensionBeam to enable/disable drumloop trig.

; 

<CsOptions>

;CsoundAV command line, edit to suit your platform and choice of Csound version
-+X -+K -+Q -b2048 
;enable midi in and audio out

</CsOptions>


<CsInstruments>


	sr = 44100  
	kr = 441
	ksmps = 100
	nchnls = 2	

	massign 1,3
	girevb	init 0
	gigate	init 0
	gkdb3trig	init 0
	gkdb3togl	init 0
	gkrevbsend	init 1
	
	zakinit		3,3

;	initc7	2, 1, 0
;	initc7	2, 2, 0


instr 1
gklfo2	oscil	0.5, 0.14 , 93	
kdb3		ctrl7	1, 3, 0, 127			;ch1, midi ctrl, min, max
gkdb3trig	trigger	kdb3, 20, 0			; make trigger of db2 signal
gkdb3togl	= gkdb3togl + gkdb3trig 
gkdb3togl	= (gkdb3togl > 1 ? 0 : gkdb3togl)	; toggle
;ktogltrig	trigger	gkdb3togl, 0.5, 0		; trigger when toggle on
;schedkwhen	ktogltrig,  0, 0,  2, 0, 65		; trig reverb/direct balance of random drumfills
endin

; **** reverb/direct balance of random drumfills ***
;instr 2
;gkrevbsend	linseg	1, 30, 1, 30, 4, 1, 4
;endin
	
;********************* FM SUBBASS + random drumfills *********************

	instr	3
inum	notnum
icps1	cpsmidi
icps	= icps1/4
iamp	ampmidi	2000
kctrl1	ctrl7	2, 1, 0, 1			;ch1, midi ctrl1, min, max
kctrl2	ctrl7	2, 2, 0, 1			;ch1, midi ctrl1, min, max
kdb3		ctrl7	1, 3, 0, 127			;ch1, midi ctrl, min, max
kdb3trig	trigger	kdb3, 20, 0			; make trigger of db2 signal

kctrl1	= 0.9
kctrl2	= 0.22
;kcutoff	init 0
;kcutoff	= icps1+(kctrl1*icps1)

	klfo1	oscil	0.5, 0.08, 93	
	klfo2	oscil	0.5, 0.14 , 93	
	klfo3	oscil	0.5, 0.26 , 93
	klfo4	oscil	0.5, 0.48 , 93
	klfo5	oscil	0.5, 0.87 , 93

	klfo1	= klfo1 + 0.5
	klfo2	= klfo2 + 0.5
	klfo3	= klfo3 + 0.5
	klfo4	= klfo4 + 0.5
	klfo5	= klfo5 + 0.5


kpregain	= 2 ;klfo2 + 0.5
kpostgain	init 0.55
kshape1		= klfo5*0.2
kshape2		= kctrl1*1.5


	a_amp	linenr	iamp, 0.001, 0.01, 0.1
	k_env2	linsegr	0, 0.01, 1, 0.05, 1, 0.2, 0.3, 0.1, 0

	kfmndx	= klfo3 * 20 + 20 + (kctrl2*400) 	;fm index, amplitude of modulator

	a1	oscili	kfmndx, icps,   93
	afmcps	= a1+icps
	a2	oscili	a_amp,  afmcps, 93
	a2	distort1	a2, kpregain, kpostgain, kshape1, kshape2 *k_env2

; random drumfills
icpsD	= 1
i_origD = 1
iampD	ampmidi 22000
ifnoD	= rnd(8.9) + 1
ifnoD	= (inum == 55 ? rnd(2.9) + 11 : ifnoD)		; single drumnotes for notenum 55
;ifnoD	= (inum == 56 ? rnd(2.9) + 11 : ifnoD)		; single drumnotes for notenum 56
ifnoD	= (inum == 57 ? rnd(2.9) + 11 : ifnoD)		; single drumnotes for notenum 57
ifnoD	= (inum == 58 ? rnd(2.9) + 11 : ifnoD)		; single drumnotes for notenum 58
ifnoD	= (inum == 68 ? rnd(2.9) + 11 : ifnoD)		; single drumnotes for notenum 68
ifnoD	= (inum == 72 ? rnd(2.9) + 11 : ifnoD)		; single drumnotes for notenum 72
;ifnoD	= (inum == 59 ? rnd(2.9) + 14 : ifnoD)		; double (8ths) drumnotes for notenum 59
ifnoD	= (inum == 66 ? rnd(2.9) + 14 : ifnoD)		; double (8ths) drumnotes for notenum 66
iampD	= (ifnoD > 10 ? iampD * 0.7 : iampD)		; lower iamp for singles and doubles
k_ampD	linenr iampD, 0, 0.6, .01 

	a3,a4	loscil	k_ampD, icpsD, ifnoD, i_origD

irevb	= rnd(0.1) + 0.02				; random reverb send
irevb	= (int(ifnoD) == 4 ? 0.4 : irevb)		; audio sample number 4 always gets lots of reverb
;irevb	= irevb * i(gkrevbsend)
idirct	= 1
;idirct	= idirct * (1/i(gkrevbsend))
;print idirct
;print irevb
;printk2	gkrevbsend
itrig	= (inum = 53 ? 1 : 0)
ktrig	trigger	itrig, 0.5, 0
if gkdb3togl = 0 goto contin
schedkwhen		ktrig,  0, 1,  4, 0, -1	; trig drumloop
contin:
itrigo	= (inum = 77 ? 1 : 0)
ktrigo	trigger	itrigo, 0.5, 0
schedkwhen		ktrigo,  0, 0, -4, 0, 1	; off drumloop

;*** crashes ***
icrash	= (inum > 79 ? 1 : 0)
if icrash == 0 goto skipcrash
a1	= 0	; no bassnotes, kybd "split"
a2	= 0
a3	= 0	; no drumfills, kybd "split"
a4	= 0
kcrash	trigger	icrash, 0.5, 0
iampC	= 9000
icpsC	= 0.7
iorigC	= 1
ifnoC	= (inum%2) + 30
ifnoC	= (inum == 80 ? 32 : ifnoC)
iampC	= (inum == 80 ? 29000 : iampC)
icpsC	= (inum == 80 ? 1 : icpsC)
schedkwhen		kcrash,  0, 0,  5, 0, 3, iampC, icpsC, ifnoC	; trig crash
skipcrash:

aLeft	= a2  + (a3 * idirct)
aRight	= a2 + (a4 * idirct) 
girevb	= irevb
	zawm	(a3+a4)*irevb, 1
	zawm	a3, 2
	zawm	a4, 3

	outs	aLeft,aRight
	endin

; **** drumloop ***
instr	4
icps	= 1
i_orig	= 1
ifno	= 20
iamp 	= 29000
	a1,a2	loscil	iamp, icps, ifno, i_orig
outs	a1,a2
endin

; **** crashes ***
instr	5
	a1,a2	loscil	p4, p5, p6, 1
	zawm	(a1+a2)*0.3, 1
	outs	a1,a2
endin

;****************************************************************
instr 10	; filter and dist instr

a3	zar 	2
a4	zar	3


kpregain	= 2 
kpostgain	= 0.1
kshape1		= 0.2
kshape2		= 1.5

	a3	distort1	a3, kpregain, kpostgain, kshape1, kshape2
	a4	distort1	a4, kpregain, kpostgain, kshape1, kshape2

	kfreq	= 2400+(gklfo2*1000)
	kq	= 0.01*kfreq
	a3f,ahp,abp	svfilter	a3, kfreq, kq
	a3f	balance	a3f, a3
	a4f,ahp,abp	svfilter	a4, kfreq, kq
	a4f	balance	a4f, a4
zawm	(a3+a4)*girevb, 1
outs	a3f, a4f

endin
;****************************************************************
instr 11	; bogus, no sound
a1	= 0
outs	a1,a1
endin
;****************************************************************

;*********************************************************	
; Program setup
;*********************************************************	
	instr 20

	outipc	2, 71, 0, 127		; program change to TC Fireworx


;**tempo control for TC Fireworx
;************************************
;osc freq of 1 = 120 bpm
;this song's bpm = 134
itpofrq	= 134/120
ktpo	oscil	63, itpofrq, 94		; square wave oscillator for tempo control
ktpo	= ktpo + 63
outkc	2, 12, ktpo, 0, 127		; send midi ctrl value

	endin
;*********************************************************	
;*********************************************************	

;****************************************************************
; WG reverb instr
;****************************************************************

; 8 delay line FDN reverb, with feedback matrix based upon 
; physical modeling scattering junction of 8 lossless waveguides
; of equal characteristic impedance. Based on Julius O. Smith III, 
; "A New Approach to Digital Reverberation using Closed Waveguide
; Networks," Proceedings of the International Computer Music 
; Conference 1985, p. 47-53 (also available as a seperate
; publication from CCRMA), as well as some more recent papers by
; Smith and others.
;
; Coded by Sean Costello, October 1999.
; Small modifications by Oeyvind Brandtsegg, 2001.

	instr 498        

ain	zar	1			; input signal

kpre	= 30				; predelay is in millisecs
a1	vdelay	ain, kpre, 1000		; Pre Delay

inlevl	= 0.28				; input level
ioutlevl = 0.3				; output level
klfroll		= 160			; LF rolloff freq

kgain 		= 0.94			; gain of reverb. Adjust empirically
                			; for desired reverb time. .6 gives
                			; a good small "live" room sound, .8
                			; a small hall, .9 a large hall,
                			; .99 an enormous stone cavern.

kpitchmod	= 0.98			; amount of random pitch modulation
                			; for the delay lines. 1 is the "normal"
                			; amount, but this may be too high for
                			; held pitches such as piano tones.
                			; Adjust to taste.

ktone 		= 12000			; Cutoff frequency of lowpass filters
                			; in feedback loops of delay lines,
                			; in Hz. Lower cutoff frequencies results
                			; in a sound with more high-frequency
                			; damping.

        
afilt1 init 0
afilt2 init 0
afilt3 init 0
afilt4 init 0
afilt5 init 0
afilt6 init 0
afilt7 init 0
afilt8 init 0

; Delay times chosen to be prime numbers.
; Works with sr=44100 ONLY. If you wish to
; use a different delay time, find some new
; prime numbers that will give roughly the
; same delay times for the new sampling rate. 
; Or adjust to taste.
idel1 = (2473.000/sr)
idel2 = (2767.000/sr)
idel3 = (3217.000/sr)
idel4 = (3557.000/sr)
idel5 = (3907.000/sr)
idel6 = (4127.000/sr)
idel7 = (2143.000/sr)
idel8 = (1933.000/sr)

; k1-k8 are used to add random pitch modulation to the
; delay lines. Helps eliminate metallic overtones
; in the reverb sound.
k1      randi   .001, 3.1, .06
k2      randi   .0011, 3.5, .9
k3      randi   .0017, 1.11, .7
k4      randi   .0006, 3.973, .3
k5      randi   .001, 2.341, .63
k6      randi   .0011, 1.897, .7
k7      randi   .0017, 0.891, .9
k8      randi   .0006, 3.221, .44

; apj is used to calculate "resultant junction pressure" for 
; the scattering junction of 8 lossless waveguides
; of equal characteristic impedance. If you wish to
; add more delay lines, simply add them to the following 
; equation, and replace the .25 by 2/N, where N is the 
; number of delay lines.
apj = .25 * (afilt1 + afilt2 + afilt3 + afilt4 + afilt5 + afilt6 + afilt7 + afilt8)

a1	= a1 * inlevl

adum1   delayr  1
adel1   deltapi idel1 + k1 * kpitchmod
        delayw  a1 + apj - afilt1

adum2   delayr  1
adel2   deltapi idel2 + k2 * kpitchmod
        delayw  a1 + apj - afilt2

adum3   delayr  1
adel3   deltapi idel3 + k3 * kpitchmod
        delayw  a1 + apj - afilt3

adum4   delayr  1
adel4   deltapi idel4 + k4 * kpitchmod
        delayw  a1 + apj - afilt4

adum5   delayr  1
adel5   deltapi idel5 + k5 * kpitchmod
        delayw  a1 + apj - afilt5

adum6   delayr  1
adel6   deltapi idel6 + k6 * kpitchmod
        delayw  a1 + apj - afilt6

adum7   delayr  1
adel7   deltapi idel7 + k7 * kpitchmod
        delayw  a1 + apj - afilt7

adum8   delayr  1
adel8   deltapi idel8 + k8 * kpitchmod
        delayw  a1 + apj - afilt8

; 1st order lowpass filters in feedback
; loops of delay lines.
afilt1  tone    adel1 * kgain, ktone
afilt2  tone    adel2 * kgain, ktone
afilt3  tone    adel3 * kgain, ktone
afilt4  tone    adel4 * kgain, ktone
afilt5  tone    adel5 * kgain, ktone
afilt6  tone    adel6 * kgain, ktone
afilt7  tone    adel7 * kgain, ktone
afilt8  tone    adel8 * kgain, ktone

; The outputs of the delay lines are summed
; and sent to the stereo outputs. This could
; easily be modified for a 4 or 8-channel 
; sound system.
aoutL = (afilt1 + afilt3 + afilt5 + afilt7) * ioutlevl 
aoutL buthp	aoutL, klfroll
aoutR = (afilt2 + afilt4 + afilt6 + afilt8) * ioutlevl 
aoutR buthp	aoutR, klfroll

;Send to output
	outs	aoutL, aoutR

endin
;****************************************************************
;****************************************************************

;****************************************************************
; clear zak
;****************************************************************
	instr 500
	zacl	0,3
	endin
;****************************************************************
;****************************************************************


</CsInstruments>


<CsScore>

f1  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs1.wav"  0  0  0
f2  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs2.wav"  0  0  0
f3  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs3.wav"  0  0  0
f4  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs4.wav"  0  0  0
f5  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs5.wav"  0  0  0
f6  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs6.wav"  0  0  0
f7  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs7.wav"  0  0  0
f8  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs8.wav"  0  0  0
f9  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUs9.wav"  0  0  0

f11  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsSingle1.wav"  0  0  0
f12  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsSingle2.wav"  0  0  0
f13  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsSingle3.wav"  0  0  0
f14  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsDouble1.wav"  0  0  0
f15  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsDouble2.wav"  0  0  0
f16  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsDouble3.wav"  0  0  0

f20  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsSoftly3.aif"  0  0  0

f30  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/BD_crash.wav"  0  0  0
f31  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/SnareCrash.wav"  0  0  0
f32  0  0    1  "E:/SamplesLive/Kroyt/RockUsSoftly/RockUsStart.wav"  0  0  0

f93  0 8192 10   1    ;sine
f94 0 128    7   1 64 1 0 -1 64 -1  	; square

f100 0 128 5   0.01 128 1
f101 0 128 9   0.25 1   0


i1 0 6000	; ctrl
;i10 0 6000	; filter & dist
;i11 0 6000	; bogus, no sound
i20 0 5		; TC pgm setup
i498 0 6000	; reverb
i500 0 6000	; clear zak channels

e

</CsScore>


</CsoundSynthesizer>
